/*
 *   errno.h -- ANSI 
 *
 *   Error code values.
 *
 *           Copyright (c) 1990, MetaWare Incorporated
 */

#ifndef _ERRNO_H
#define _ERRNO_H

enum Values_for_errno {
No_error_occurred,     Error_invalid_function,    Error_file_not_found,
Error_path_not_found,  Error_too_many_open_files, Error_access_denied,
Error_invalid_handle,  Error_arena_trashed,       Error_not_enough_memory,
Error_invalid_block,   Error_bad_environment,     Error_bad_format,
Error_invalid_access,  Error_invalid_data,        Error_reserved,
Error_invalid_drive,   Error_current_directory,   Error_not_same_device,
Error_no_more_files,   Error_invalid_radix,       Error_numeric_read_failed,
Error_write_failed,    Error_eof_encountered,     Error_out_of_domain,
Error_out_of_range};

extern int errno;

#define E2BIG Error_bad_environment
#define EACCES Error_access_denied
#define EAGAIN -1
#define EBADF Error_invalid_handle
#define EBUSY -1
#define ECHILD -1
#define EDEADLOCK 25
#define EDOM 23
#define EEXIST -1
#define EFAULT -1
#define EFBIG -1
#define EINTR -1
#define EINVAL Error_invalid_function
#define EIO -1
#define EISDIR -1
#define EMFILE Error_too_many_open_files
#define EMLINK -1
#define ENFILE Error_too_many_open_files
#define ENODEV Error_invalid_drive
#define ENOENT Error_file_not_found
#define ENOEXEC Error_bad_format
#define ENOMEM Error_not_enough_memory
#define ENOSPC -1
#define ENOTBLK -1
#define ENOTDIR -1
#define ENOTTY -1
#define ENXIO -1
#define EPERM -1
#define EPIPE -1
#define ERANGE 24
#define EROFS -1
#define ESPIPE -1
#define ESRCH -1
#define ETXTBSY -1
#define EUCLEAN -1
#define EXDEV -1
#define EZERO No_error_occurred

#endif /* _ERRNO_H */
