/*
 *   limits.h -- ANSI 
 *
 *   Constants that constrain the representation of numerical values.
 *
 *           Copyright (c) 1990, MetaWare Incorporated
 */

#ifndef _LIMITS_H
#define _LIMITS_H

/* Sizes of Integral types		*/

/* maximum number of bits for smallest object (byte) */
#define CHAR_BIT			 8

/* maximum value for an object of type char */
#define CHAR_MAX		       255

/* minimum value for an object of type char */
#define CHAR_MIN			 0

/* maximum value for an object of type signed char */
#define SCHAR_MAX		      +127

/* minimum value for an object of type signed char */
#define SCHAR_MIN		      -128

/* maximum value for an object of type unsigned char */
#define UCHAR_MAX		       255

/* maximum number of bytes in a multibyte character */
#define MB_LEN_MAX			 1

/* maximum value for an object of type short */
#define SHRT_MAX		    +32767

/* minimum value for an object of type short */
#define SHRT_MIN		    -32768

/* maximum value for an object of type signed short */
#define USHRT_MAX		     65535 /* 65_535 */

/* maximum value for an object of type long */
#define LONG_MAX	       +2147483647 /* 2_147_483_647 */

/* minimum value for an object of type long */
#define LONG_MIN	       -2147483648 /* 2_147_483_648 */

/* maximum value for an object of type unsigned long */
#define ULONG_MAX		4294967295 /* 4_294_967_295 */

/* maximum value for an object of type int */
#define INT_MAX 		    LONG_MAX

/* minimum value for an object of type int */
#define INT_MIN 		    LONG_MIN

/* maximum value for an object of type unsigned int */
#define UINT_MAX		    ULONG_MAX

#endif /* _LIMITS_H */
