/*
 *   process.h -- non-ANSI 
 *
 *   Functions and constants needed to control the active
 *   processes running in the computer system.
 *
 *           Copyright (c) 1990, MetaWare Incorporated
 */

#ifndef _PROCESS_H
#define _PROCESS_H

#define _P_WAIT 0

extern int _getpid(void);
extern int _spawnl(int __mode, char * __path, char * __arg0, ...);
extern int _spawnle(int __mode, char * __path, char * __arg0, ...);
extern int _spawnlp(int __mode, char * __path, char * __arg0, ...);
extern int _spawnlpe(int __mode, char * __path, char * __arg0, ...);
extern int _spawnv(int __mode, char * __path, char ** __argv);
extern int _spawnve(int __mode, char * __path, char ** __argv, char ** __envp);
extern int _spawnvp(int __mode, char * __path, char ** __argv);
extern int _spawnvpe(int __mode, char * __path, char ** __argv, char ** __envp);
extern int _execl (char *__path, char *__arg0, char *__arg1, ...); 
extern int _execle (char *__path, char *__arg0, char *__arg1, ...);
extern int _execlp (char *__path, char *__arg0, char *__arg1, ...); 
extern int _execlpe (char *__path, char *__arg0, char *__arg1, ...);
extern int _execv (char *__path, char **__argv);
extern int _execve (char *__path, char *__argv, char **__envp);
extern int _execvp (char *__path, char **__argv);
extern int _execvpe (char *__path, char **__argv, char **__envp);

#ifdef __HIGHC__

#define P_WAIT _P_WAIT

extern void abort(void);
extern void exit(int __status);
extern int getpid(void);
extern int spawnl(int __mode, char * __path, char * __arg0, ...);
extern int spawnle(int __mode, char * __path, char * __arg0, ...);
extern int spawnlp(int __mode, char * __path, char * __arg0, ...);
extern int spawnlpe(int __mode, char * __path, char * __arg0, ...);
extern int spawnv(int __mode, char * __path, char ** __argv);
extern int spawnve(int __mode, char * __path, char ** __argv, char ** __envp);
extern int spawnvp(int __mode, char * __path, char ** __argv);
extern int spawnvpe(int __mode, char * __path, char ** __argv, char ** __envp);
extern int execl (char *__path, char *__arg0, char *__arg1, ...); 
extern int execle (char *__path, char *__arg0, char *__arg1, ...);
extern int execlp (char *__path, char *__arg0, char *__arg1, ...); 
extern int execlpe (char *__path, char *__arg0, char *__arg1, ...);
extern int execv (char *__path, char **__argv);
extern int execve (char *__path, char *__argv, char **__envp);
extern int execvp (char *__path, char **__argv);
extern int execvpe (char *__path, char **__argv, char **__envp);
extern int system(const char * __string);

#endif

#endif /* _PROCESS_H */
