/*
 *   stat.h -- non-ANSI
 *
 *   Function, types and constants for determining device and file status.
 *
 *           Copyright (c) 1990, MetaWare Incorporated
 */

#ifndef _STAT_H
#define _STAT_H

#define _S_IFMT   61440
#define _S_IFDIR  16384
#define _S_IFCHR   8192
#define _S_IFREG  32768
#define _S_IREAD    256
#define _S_IWRITE   128
#define _S_IEXEC     64

#ifndef _TIME_T_DEFINED
#define _TIME_T_DEFINED
typedef long time_t;
#endif

#ifndef _INO_T_DEFINED
#define _INO_T_DEFINED
typedef unsigned short _ino_t;
#endif

#ifndef _DEV_T_DEFINED
#define _DEV_T_DEFINED
typedef short _dev_t;
#endif

#ifndef _OFF_T_DEFINED
#define _OFF_T_DEFINED
typedef long _off_t;
#endif

#ifndef _STAT_DEFINED
#define _STAT_DEFINED
struct _stat {
	_dev_t st_dev;
	_ino_t st_ino;
	unsigned short st_mode;
	short st_nlink;
	short st_uid;
	short st_gid;
	_dev_t st_rdev;
	_off_t st_size;
	time_t st_atime;
	time_t st_mtime;
	time_t st_ctime;
	};
#endif

extern _stat(char * __path, struct _stat * __buffer);

#if __HIGHC__

#define S_IFMT   _S_IFMT
#define S_IFDIR  _S_IFDIR
#define S_IFCHR  _S_IFCHR
#define S_IFREG  _S_IFREG
#define S_IREAD  _S_IREAD
#define S_IWRITE _S_IWRITE
#define S_IEXEC  _S_IEXEC

#define ino_t _ino_t
#define dev_t _dev_t
#define off_t _off_t
#ifndef _STAT_DEFINED_
#define _STAT_DEFINED_
struct stat {
	_dev_t st_dev;
	_ino_t st_ino;
	unsigned short st_mode;
	short st_nlink;
	short st_uid;
	short st_gid;
	_dev_t st_rdev;
	_off_t st_size;
	time_t st_atime;
	time_t st_mtime;
	time_t st_ctime;
	};
#endif
extern stat(char * __path, struct stat * __buffer);

#endif /* __HIGHC__ */

#endif /* _STAT_H */
