/*
 *   time.h -- ANSI
 *
 *   Functions, types, and a macro for manipulating
 *   representations of time.
 *
 *           Copyright (c) 1990, MetaWare Incorporated
 */

#ifndef _TIME_H
#define _TIME_H

#if __HIGHC__
#define Local_time_zone 8     /* delta from gmt in hours */
#define CLK_TCK CLOCKS_PER_SEC  /* obsolete. */
extern void tzset(void);  /* non-ansi function name. */
#endif
extern void _tzset(void);  /* extra-ansi function name. */

extern long _timezone; /* delta from gmt in seconds; initialized to Local_time_zone * 3600 in module timezone.c */

#define CLOCKS_PER_SEC 100	/* new ANSI name. */

extern int _daylight;      /* zero if not daylight savings time */
extern char * _tzname[2];  /* standard and daylight time zone names */
#ifdef __HIGHC__
extern long timezone; /* defined for msc compatibility only; not needed otherwise */
#pragma alias(timezone,"_timezone");
extern int daylight;      /* zero if not daylight savings time */
#pragma alias(daylight,"_daylight");
extern char * tzname[2];  /* standard and daylight time zone names */
#pragma alias(tzname,"_tzname");
#endif

#ifndef _SIZE_T_DEFINED
#define _SIZE_T_DEFINED
typedef unsigned int size_t;
#endif

typedef long time_t;
typedef long clock_t;

struct tm {
	   int tm_sec;	  /*seconds after the minute- 0..59*/
	   int tm_min;	  /*minutes after the hour- 0..59*/
	   int tm_hour;   /*hours since midnight- 0..23*/
	   int tm_mday;   /*day of the month- 1..31*/
	   int tm_mon;	  /*month of the year- 0..11*/
	   int tm_year;   /*years since 1900*/
	   int tm_wday;   /*days since Sunday- 0..6*/
	   int tm_yday;   /*day of the year- 0..365*/
	   int tm_isdst;  /*daylight savings time- boolean (0..1)*/
	   };

extern size_t strftime(char *__s, size_t __maxsize,
                       const char *__format, const struct tm *__timeptr);
extern time_t mktime(struct tm *);
extern char * _strdate(char *);
extern char * _strtime(char *);

extern clock_t clock(void); /* Time of day in 100ths of a second. */
extern time_t time(time_t *__timer);
extern char *asctime(const struct tm *__timeptr);
extern char *ctime(const time_t *__timer);
extern double difftime(time_t __time2, time_t __time1);
extern struct tm *gmtime(const time_t *__timer);
extern struct tm *localtime(const time_t *__timer);

#endif /* _TIME_H */
